package com.cirmuller.maidaddition.capability;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.cirmuller.maidaddition.api.IChunkLoadingCapability;
import com.cirmuller.maidaddition.capability.ChunkLoadingCapability;
import com.cirmuller.maidaddition.capability.ModCapability;
import com.github.tartaricacid.touhoulittlemaid.entity.passive.EntityMaid;
import net.minecraft.core.Direction;
import net.minecraft.world.level.Level;
import net.minecraftforge.common.capabilities.Capability;
import net.minecraftforge.common.capabilities.ICapabilityProvider;
import net.minecraftforge.common.util.LazyOptional;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public class ChunkLoadingCapabilityProvider implements ICapabilityProvider {
  ChunkLoadingCapability chunkLoadingCapability;
  
  EntityMaid maid;
  
  Level level;
  
  public static Logger logger = LogManager.getLogger("maidaddition");
  
  public ChunkLoadingCapabilityProvider(EntityMaid maid) {
    this.maid = maid;
    this.chunkLoadingCapability = null;
  }
  
  @NotNull
  public <T> LazyOptional<T> getCapability(@NotNull Capability<T> capability, @Nullable Direction direction) {
    if (capability == ModCapability.CHUNK_LOADING_CAPABILITY)
      return LazyOptional.of(this::getOrCreateCapability).cast(); 
    return LazyOptional.empty();
  }
  
  private IChunkLoadingCapability getOrCreateCapability() {
    if (this.chunkLoadingCapability == null) {
      this.chunkLoadingCapability = new ChunkLoadingCapability(this.maid);
      return (IChunkLoadingCapability)this.chunkLoadingCapability;
    } 
    return (IChunkLoadingCapability)this.chunkLoadingCapability;
  }
}
